package pizzaareusllc;

import java.util.Arrays;

public class Pizza {

    public String pizzaType;
    public String[] doughPreparation;
    public String[] listOfToppings;
    public String[] bakingProcess;
    public PizzaSize size;
    public String[] pizzaPreparation;

    public Pizza(PizzaSize size) {
        this.size = size;
        setDoughPreparation();
        setBakingProcess();
    }

    public void addTopping(String newTopping) {
        int listSize = listOfToppings.length;
        String[] newList = new String[listSize + 1];
        int arrayIndex = 0;
        for(String existingTopping : listOfToppings) {
            newList[arrayIndex] = existingTopping;
            arrayIndex++;
        }
        newList[arrayIndex] = newTopping;
        listOfToppings = newList;
    }

    public void removeTopping(String removeTopping) {
        int listSize = listOfToppings.length;
        String[] newList = new String[listSize - 1];
        int arrayIndex = 0;
        for(String existingTopping : listOfToppings) {
            if (!existingTopping.equalsIgnoreCase(removeTopping)) {
                newList[arrayIndex] = existingTopping;
                arrayIndex++;
            }
        }
        listOfToppings = newList;
    }
    
    public void addPreparationStep(String newStep) {
        int listSize = pizzaPreparation.length;
        String[] newList = new String[listSize + 1];
        int arrayIndex = 0;
        for(String existingStep : pizzaPreparation) {
            newList[arrayIndex] = existingStep;
            arrayIndex++;
        }
        newList[arrayIndex] = newStep;
        pizzaPreparation = newList;
    }

    public void removePreparationStep(String removeStep) {
        int listSize = pizzaPreparation.length;
        String[] newList = new String[listSize - 1];
        int arrayIndex = 0;
        for(String existingStep : pizzaPreparation) {
            if (!existingStep.contains(removeStep)) {
                newList[arrayIndex] = existingStep;
                arrayIndex++;
            }
        }
        pizzaPreparation = newList;
    }

    public void printPizzaDescription() {
        // later on
    }

    private void setDoughPreparation() {
        doughPreparation = new String[]{
            "1) Whisk 3 3/4 cups flour and 1 1/2 teaspoons salt.",
            "2) Make a well and add 1 1/3 cups warm water, 1 tablespoon sugar and 1 packet yeast.",
            "3) When foamy, mix in 3 tablespoons olive oil; knead until smooth, 5 minutes.",
            "4) Brush with olive oil, cover in a bowl and let rise until doubled, about 1 hour 30 minutes.",
            "5) Divide into two 1-pound balls.",
            "6) Use 1 pound per recipe unless noted."};
    }

    private void setBakingProcess() {
        bakingProcess = new String[]{
            "1) Place a pizza stone or an inverted baking sheet on the lowest oven rack and preheat to 500 degrees.",
            "2) Stretch 1 pound dough on a floured pizza peel, large wooden cutting board or parchment paper.",
            "3) Top as desired, then slide the pizza (with the parchment paper, if using) onto the stone or baking sheet. Bake until golden, about 15 minutes."
        };
    }

    public void printDoughPreparationInstructions() {
        System.out.println("\n************************************************");
        System.out.println("Steps on how to prepare a pizza dough:");
        for (String step : doughPreparation) {
            System.out.println(step);
        }
    }

    public void printBakingProcessInstructions() {
        System.out.println("\n************************************************");
        System.out.println("Steps on how to bake a pizza:");
        for (String step : bakingProcess) {
            System.out.println(step);
        }
    }

    public void printListOfToppings() {
        System.out.println("\n************************************************");
        System.out.println("List of toppings for " + pizzaType + " pizza:");
        for (String topping : listOfToppings) {
            System.out.println(topping);
        }
    }

    public void printPizzaPreparationInstructions() {
        System.out.println("\n************************************************");
        System.out.println("Pizza Preparation for " + pizzaType + " pizza:");
        for (String step : pizzaPreparation) {
            System.out.println(step);
        }
    }

    public void setPizzaSize(PizzaSize size) {
        this.size = size;
    }
}
